module Moip
    module Pagamento

        def Moip::Pagamento::criar_pagamento(pacote, cobranca)    
            auth = Moip2::Auth::Basic.new(MOIP_TOKEN, MOIP_KEY)
            client = Moip2::Client.new(:development, auth)
            api = Moip2::Api.new(client)

            #pp api.notifications.find_all
            #api.notifications.delete("NPR-YYLCEM7GX4KD")
            # api.notifications.create(
            #     events: ["ORDER.*", "PAYMENT.*"],
            #     target: "http://webhook.site/5ebb1acd-11c5-4f43-8222-837523e11ee8",
            #     media: "WEBHOOK"
            # )

            moip_cliente = Pagamento::criar_ou_buscar_cliente(api, pacote.usuario)
            moip_pedido = Pagamento::criar_pedido(api, pacote)
            moip_pagamento = Pagamento::pagar(api, moip_pedido, pacote, cobranca)

            pp moip_cliente
        end

        def Moip::Pagamento::criar_ou_buscar_cliente(api, usuario)
            if usuario.codigo_moip != nil
                customer = api.customer.show(usuario.codigo_moip)
            else
                options = {
                                                    ownId: usuario.id,
                                                    fullname: usuario.nome,
                                                    email: usuario.email,
                                                    birthDate: usuario.data_nascimento,
                                                    taxDocument: {
                                                        type: 'CPF',
                                                        number: usuario.cpf
                                                    },
                                                    shippingAddress: {
                                                        city: usuario.cidade.nome,
                                                        complement: usuario.endereco_complemento,
                                                        district: usuario.endereco_bairro,
                                                        street: usuario.endereco,
                                                        streetNumber: usuario.endereco_numero,
                                                        zipCode: usuario.endereco_cep,
                                                        state: usuario.cidade.estado.uf,
                                                        country: "BRA"
                                                    }
                }

                customer = api.customer.create(options)
                usuario.codigo_moip = customer["id"]
                usuario.save!
            end
            customer
        end

        def Moip::Pagamento::criar_pedido(api, pacote)
            order = api.order.create({
                                            own_id: pacote.id,
                                            items: [
                                                {
                                                    product: "Pacote PESK",
                                                    quantity: 1,
                                                    detail: "Pacote de pesca via Pesk",
                                                    price: pacote.valor * 100
                                                }
                                            ],
                                            customer: {
                                                own_id: pacote.usuario.id,
                                                fullname: pacote.usuario.nome,
                                                email: pacote.usuario.email,
                                            }
                                    })
            order
        end

        def Moip::Pagamento::pagar(api, order, pacote, cobranca)
            pagamento =  api.payment.create(order["id"], {
                installment_count: cobranca[:parcelas],
                funding_instrument: {
                    method: "CREDIT_CARD",
                    credit_card: {
                        expirationMonth: "10",
                        expirationYear: "18",
                        number: "4485360893426969",
                        cvc: "311",
                        holder: {
                            fullname: cobranca[:nome],
                            birthdate: cobranca[:nascimento],
                            tax_document: {
                                type: "CPF",
                                number: cobranca[:cpf]
                            }
                        }
                    }
                }
            })
            pagamento
        end

    end
end